/*
	$Id: ToplevelCompounds.java 296 2006-09-07 18:20:59Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.NodeList;
import org.w3c.dom.Element;
import java.util.LinkedList;
import java.io.PrintWriter;

/**
   ¤Τޤ϶Τޤ󷿤ΥåȤǤ

   ȥåץ٥륳ѥɤΥåȤݻޤ
*/
public class ToplevelCompounds {

    /** ȥåץ٥륳ѥɤΥꥹ */
    private LinkedList<ToplevelCompound> v;

    /** 饹 */
    private Class g;

    /**
       ȥåץ٥륳ѥɤΥåȤޤ

       @param g 饹
       @param nodes structǤޤunionǤޤenumǤΥΡɥ
       
    */
    public ToplevelCompounds(final Class g, final NodeList nodes) {
	this.g = g;
	v = new LinkedList<ToplevelCompound>();

	for (int k = 0, n = nodes.getLength(); k < n; ++k) {
	    Element elem = (Element) nodes.item(k);
	    String name = elem.getNodeName();
	    ToplevelCompound m;
	    if (name.equals("struct")) {
		m = g.createStruct(elem);
	    } else if (name.equals("union")) {
		m = g.createUnion(elem);
	    } else if (name.equals("enum")) {
		m = g.createEnum(elem);
	    } else {
		throw new NodeException(elem, "unknown element name");
	    }
	    v.add(m);
	}
    }

    /**
       ȥåץ٥륳ѥɤΥɤϤޤ

       @param wr 饤
    */
    public void printCode(final PrintWriter wr) {
	for (ToplevelCompound m : v) {
	    wr.println("");
	    m.printCode(wr);
	}
    }
}
